/* Sensor2

  R4 and R4.5 version Copyright (c) 1999 Andrew Vessey
  Original R3 version Copyright (c) 1998 Mathias Agopian
  All Rights Reserved.

  Contributing Author(s):

     Andrew Vessey <andrew@pixira.com> (R4 stuff - prefs, minisensor)
     Mathias Agopian (original R3 version of sensorapp, sensorwin, mlm78
     Marco Nelissen <marcone@xs4all.nl> (bubblehelper class)

  The contributing author(s) would like to thank all those who
  helped with testing, bug fixes, and patience.  This wouldn't
  have been possible without all of you.

  COPYRIGHT NOTICE:
 
  This software and documentation is provided "as is," and
  the copyright holders and contributing author(s) make no
  representations or warranties, express or implied, including
  but not limited to, warranties of merchantability or fitness
  for any particular purpose or that the use of the software or
  documentation will not infringe any third party patents,
  copyrights, trademarks or other rights. 

  The copyright holders and contributing author(s) will not be
  liable for any direct, indirect, special or consequential damages
  arising out of any use of the software or documentation, even if
  advised of the possibility of such damage.

  Permission is hereby granted to use, copy, modify, and distribute
  this source code, or portions hereof, documentation and executables,
  for any purpose, without fee, subject to the following restrictions:

  1. The origin of this source code must not be misrepresented.
  2. Altered versions must be plainly marked as such and must
     not be misrepresented as being the original source.
  3. This Copyright notice may not be removed or altered from any
     source or altered source distribution.
 
  The copyright holders and contributing author(s) specifically
  permit, without fee, and encourage the use of this source code
  as a component for developing system monitoring applications for 
  the BeOS.  If you use this source code in a product,
  acknowledgment is not required but would be appreciated.
*/

#include <be/storage/File.h>
#ifndef  MLM78_H
#define MLM78_H


class Mlm78
{
public:
	Mlm78();
	virtual ~Mlm78();
	status_t InitCheck(void);
	int32 Update(void);
	
public:
	float VoltVTT;
	float VoltVIO;
	float VoltP5;
	float VoltP12;
	float VoltM12;
	float VoltM5;
	float Volt5VSB;
    float VoltCore[2];
	int TempCPU[3];
	int FanCPU[3];
private:
	BFile *fSensorDevice;
};
#endif
