#include "progressbar.h"
#include <string.h>

TProgressBar::TProgressBar(BRect r, char *name)
		   : BView(r, name, B_FOLLOW_NONE, B_WILL_DRAW)
{	prevTicks = 0;
	averageVals = new int [PROGRESS_AVERAGE];
	memset (averageVals, 0, PROGRESS_AVERAGE * sizeof(int));		
	averageTot =0;		
	currentPos =1;	
	averagePos = 1;	
	count=0;	
	SetViewColor (0, 0, 0);
}

TProgressBar::~TProgressBar()
{	delete [] averageVals;
}

void	TProgressBar::Draw( BRect updateRect )
{	int seg;
	BRect drawRect=Bounds();
	SetHighColor (120, 120, 120);
	StrokeRect(drawRect);
	drawRect=Bounds();
	drawRect.top+=2;	
	drawRect.bottom-=1;
	for (seg = 0; seg < currentPos; seg++) 
	{	SetHighColor (0, 80+seg*8, 0);
		drawRect.left=seg * 7 + 1;
		drawRect.right=drawRect.left+5;
		FillRect (drawRect);
	}
	SetHighColor(75,75,75);
	for (seg = currentPos; seg < 20; seg++) 
	{	drawRect.left = seg * 7 + 1;
		drawRect.right = drawRect.left + 5;
		FillRect (drawRect);
	}
}

void 	TProgressBar ::Update(bigtime_t ticks,double scaleFactor)
{	int cpuNow,cpuAve;
		
	//get cpu activity
	cpuNow = (int)((ticks - prevTicks) * scaleFactor);
	prevTicks = ticks;
	if (cpuNow< 0) cpuNow = 0;
	else if (cpuNow > 20) cpuNow = 20;
			
	//calc average activity
	if(cpuNow==currentPos) 
		cpuAve=1+(int)((cpuNow*139.0)/20); //rapid changes...
	else
		cpuAve=1+(int) (averageTot*139.0/(PROGRESS_AVERAGE*20));
					
	BRect drawRect=Bounds();
	drawRect.top+=2;	
	drawRect.bottom-=1;
		 	
			
	//draw/delete changed bar segments
	if(cpuNow>currentPos)
		for (int counter = currentPos; counter <cpuNow; counter++) 
		{	SetHighColor (0,80+counter*8, 0);
			drawRect.left = counter * 7 + 1;
			drawRect.right = drawRect.left + 5;
			FillRect (drawRect);
		}
	else if(cpuNow<currentPos)
		for (int counter = cpuNow; counter <currentPos; counter++) 
		{	SetHighColor (75, 75, 75);
			drawRect.left = counter * 7 + 1;
			drawRect.right = drawRect.left + 5;
			FillRect (drawRect);
		}
			
	//delete the avergage line
	if(((averagePos)%7)==0)
		SetHighColor(0,0,0); //between bar segments
	else if(averagePos>=(1+cpuNow*7))
		SetHighColor(75,75,75); //off segment
	else
		SetHighColor(0,80+((int) ((averagePos-1)*20.0/139) )*8,0); //on segment	
	StrokeLine(BPoint(averagePos,drawRect.top),BPoint(averagePos,drawRect.bottom));
			
	//draw the average line
	SetHighColor(255,0,0);
	StrokeLine(BPoint(cpuAve,drawRect.top),BPoint(cpuAve,drawRect.bottom));
					
	//save vals
	currentPos = cpuNow;
	averagePos = cpuAve;
	averageTot += cpuNow-averageVals[count];
	averageVals[count]=cpuNow;
	count=(count+1)%PROGRESS_AVERAGE;
}