/*----------------------------------------------------------
  monitor.h
  
  Definitions for the sysctl interface to the lm78 driver

  Erik Hendriks
  hendriks@cesdis.gsfc.nasa.gov

  $Id: monitor.h,v 1.1 1998/07/30 17:47:33 hendriks Exp $
  ----------------------------------------------------------*/
#ifndef _MONITOR_H_
#define _MONITOR_H_

#define HM_LM78    1

#define HM_LIMITS  1
#define HM_STATUS  2
#define HM_CONTROL 3

#define HM_IN0    0x10
#define HM_IN1    0x11
#define HM_IN2    0x12
#define HM_IN3    0x13
#define HM_IN4    0x14
#define HM_IN5    0x15
#define HM_IN6    0x16

#define HM_TEMP0  0x20
#define HM_TEMP1  0x21
#define HM_TEMP2  0x22

#define HM_FAN0   0x30
#define HM_FAN1   0x31
#define HM_FAN2   0x32

#define HM_CHASSIS    0x40
#define HM_RESET      0x41
#define HM_INTERRUPTS 0x42
#define HM_BEEP       0x43

/*--- This junk is internal to the sysctl interface ---*/
/* SYSCTL type info flags */
#define SC_SIZE_MASK 0x00FF
#define SC_OP_MASK   0x0300
#define SC_TYPE_MASK 0x0c00

/* The categories of things */
#define SC_LIMIT    0x0000
#define SC_STATUS   0x0100
#define SC_CONTROL  0x0200
/*#define SC_???      0x0300*/

/* Data types */
#define SC_TYPE_NONE 0x0000
#define SC_TYPE_INT  0x0400
#define SC_TYPE_STR  0x0800
/*#define SC_TYPE_???  0x0C00*/

#endif
